gtkmm: Gtk::AccelGroup Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gtk::AccelGroup Class Reference

A Gtk::AccelGroup represents a group of keyboard accelerators, typically attached to a toplevel Gtk::Window (with Gtk::Window::add_accel_group()). More...

Inheritance diagram for Gtk::AccelGroup:
[legend]
Collaboration diagram for Gtk::AccelGroup:
[legend]

List of all members.

## Public Member Functions
virtual | ~AccelGroup ()
GtkAccelGroup* | gobj ()
| Provides access to the underlying C GObject.
const GtkAccelGroup* | gobj () const
| Provides access to the underlying C GObject.
GtkAccelGroup* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | get_is_locked () const
| Locks are added and removed using lock() and unlock().
Gdk::ModifierType | get_modifier_mask () const
| Gets a Gdk::ModifierType representing the mask for this accel_group.
void | lock ()
| Locks the given accelerator group.
void | unlock ()
| Undoes the last call to lock() on this accel_group.
bool | disconnect_key (guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator previously installed through connect().
bool | activate (GQuark accel_quark, const Glib::RefPtr< Glib::Object >& acceleratable, guint accel_key, Gdk::ModifierType accel_mods)
| Finds the first accelerator in accel_group that matches accel_key and accel_mods, and activates it.
Glib::SignalProxy3< bool, const Glib::RefPtr < Glib::Object > &, guint, Gdk::ModifierType > | signal_accel_activate ()
Glib::SignalProxy3< void, guint, Gdk::ModifierType, GClosure* > | signal_accel_changed ()
Glib::PropertyProxy_ReadOnly < bool > | property_is_locked () const
| Is the accel group locked.
Glib::PropertyProxy_ReadOnly < Gdk::ModifierType > | property_modifier_mask () const
| Modifier Mask.
## Static Public Member Functions
static Glib::RefPtr< AccelGroup > | create ()
| Creates a new Gtk::AccelGroup object.
static bool | valid (guint keyval, Gdk::ModifierType modifiers)
| Determines whether a given keyval and modifier mask constitute a valid keyboard accelerator.
static void | parse (const Glib::ustring& accelerator, guint& accelerator_key, Gdk::ModifierType& accelerator_mods)
| Parse the accelerator string.
static Glib::ustring | name (guint accelerator_key, Gdk::ModifierType accelerator_mods)
| Converts an accelerator keyval and modifier mask into a string parseable by parse().
static Glib::ustring | get_label (guint accelerator_key, Gdk::ModifierType accelerator_mods)
| Converts an accelerator keyval and modifier mask into a string which can be used to represent the accelerator to the user.
static void | set_default_mod_mask (Gdk::ModifierType default_mod_mask)
| Sets the modifiers that will be considered significant for keyboard accelerators.
static Gdk::ModifierType | get_default_mod_mask ()
| See set_default_mod_mask().
static bool | activate (Gtk::Object& object, guint accel_key, Gdk::ModifierType accel_mods)
| Finds the first accelerator in any Gtk::AccelGroup attached to object that matches accel_key and accel_mods, and activates that accelerator.
## Protected Member Functions
| AccelGroup ()
virtual void | on_accel_changed (guint keyval, Gdk::ModifierType modifier, GClosure* accel_closure)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::AccelGroup > | wrap (GtkAccelGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Gtk::AccelGroup represents a group of keyboard accelerators, typically attached to a toplevel Gtk::Window (with Gtk::Window::add_accel_group()).

Usually you won't need to create a Gtk::AccelGroup directly; instead, gtkmm automatically sets up the accelerators for your menus. Note that accelerators are different from mnemonics. Accelerators are shortcuts for activating a menu item; they appear alongside the menu item for which they're a shortcut. For example "Ctrl+Q" might appear alongside the "Quit" menu item. Mnemonics are shortcuts for GUI elements such as text entries or buttons; they appear as underlined characters. See the Gtk::Label constructor. Menu items can have both accelerators and mnemonics, of course.

You can use Gtk::Window::get_accel_group() to get an accel group for that window, then use it with other widgets too.

## Constructor & Destructor Documentation

virtual Gtk::AccelGroup::~AccelGroup | ( |  | ) | `[virtual]`

Gtk::AccelGroup::AccelGroup | ( |  | ) | `[protected]`

## Member Function Documentation

bool Gtk::AccelGroup::activate | ( | GQuark | accel_quark,
|  | const Glib::RefPtr< Glib::Object > & | acceleratable,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods
| ) |  |

Finds the first accelerator in accel_group that matches accel_key and accel_mods, and activates it.

Parameters:

  accel_quark | The quark for the accelerator name.
  acceleratable | The Object, usually a Gtk::Window, on which to activate the accelerator.
  accel_key | Accelerator keyval from a key event.
  accel_mods | Keyboard state mask from a key event.

Returns:
  `true` if an accelerator was activated and handled this keypress.

static bool Gtk::AccelGroup::activate | ( | Gtk::Object& | object,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods
| ) |  | `[static]`

Finds the first accelerator in any Gtk::AccelGroup attached to object that matches accel_key and accel_mods, and activates that accelerator.

Parameters:

  object | The Object, usually a Gtk::Window, on which to activate the accelerator.
  accel_key | Accelerator keyval from a key event.
  accel_mods | Keyboard state mask from a key event.

Returns:
  `true` if an accelerator was activated and handled this keypress.

static Glib::RefPtr<AccelGroup> Gtk::AccelGroup::create | ( |  | ) | `[static]`

Creates a new Gtk::AccelGroup object.

Returns:
  A Glib::RefPtr<> to a newly created Gtk::AccelGroup object.

bool Gtk::AccelGroup::disconnect_key | ( | guint | accel_key,
|  | Gdk::ModifierType | accel_mods
| ) |  |

Removes an accelerator previously installed through connect().

Parameters:

  accel_key | Key value of the accelerator.
  accel_mods | Modifier combination of the accelerator.

Returns:
  `true` if there was an accelerator which could be removed, `false` otherwise.

static Gdk::ModifierType Gtk::AccelGroup::get_default_mod_mask | ( |  | ) | `[static]`

See set_default_mod_mask().

bool Gtk::AccelGroup::get_is_locked | ( |  | ) | const

Locks are added and removed using lock() and unlock().

Since gtkmm 2.14:

Returns:
  `true` if there are 1 or more locks on the accel_group, `false` otherwise.

static Glib::ustring Gtk::AccelGroup::get_label | ( | guint | accelerator_key,
|  | Gdk::ModifierType | accelerator_mods
| ) |  | `[static]`

Converts an accelerator keyval and modifier mask into a string which can be used to represent the accelerator to the user.

Since gtkmm 2.6:

Parameters:

  accelerator_key | Accelerator keyval.
  accelerator_mods | Accelerator modifier mask.

Returns:
  A newly-allocated string representing the accelerator.

Gdk::ModifierType Gtk::AccelGroup::get_modifier_mask | ( |  | ) | const

Gets a Gdk::ModifierType representing the mask for this accel_group.

For example, Gdk::CONTROL_MASK, Gdk::SHIFT_MASK, etc.

Since gtkmm 2.14:

Returns:
  The modifier mask for this accel group.

const GtkAccelGroup* Gtk::AccelGroup::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkAccelGroup* Gtk::AccelGroup::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkAccelGroup* Gtk::AccelGroup::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gtk::AccelGroup::lock | ( |  | ) |

Locks the given accelerator group.

Locking an acelerator group prevents the accelerators contained within it to be changed during runtime. Refer to Gtk::AccelMap::change_entry() about runtime accelerator changes.

If called more than once, accel_group remains locked until unlock() has been called an equivalent number of times.

static Glib::ustring Gtk::AccelGroup::name | ( | guint | accelerator_key,
|  | Gdk::ModifierType | accelerator_mods
| ) |  | `[static]`

Converts an accelerator keyval and modifier mask into a string parseable by parse().

For example, if you pass in 'q' and Gdk::CONTROL_MASK, it returns "&lt;Control&gt;q".

virtual void Gtk::AccelGroup::on_accel_changed | ( | guint | keyval,
|  | Gdk::ModifierType | modifier,
|  | GClosure * | accel_closure
| ) |  | `[protected, virtual]`

static void Gtk::AccelGroup::parse | ( | const Glib::ustring & | accelerator,
|  | guint & | accelerator_key,
|  | Gdk::ModifierType& | accelerator_mods
| ) |  | `[static]`

Parse the accelerator string.

Parameters:

  accelerator | See the Gtk::AccelKey constructor for the format.
  accelerator_key | Output argument
  accelerator_mods | Output argument

Glib::PropertyProxy_ReadOnly<bool> Gtk::AccelGroup::property_is_locked | ( |  | ) | const

Is the accel group locked.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Gdk::ModifierType> Gtk::AccelGroup::property_modifier_mask | ( |  | ) | const

Modifier Mask.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

static void Gtk::AccelGroup::set_default_mod_mask | ( | Gdk::ModifierType | default_mod_mask | ) | `[static]`

Sets the modifiers that will be considered significant for keyboard accelerators.

The default mod mask is Gdk::CONTROL_MASK | Gdk::SHIFT_MASK | Gdk::MOD1_MASK, that is, Control, Shift, and Alt. Other modifiers will ignored by default. You must include at least the three default modifiers in any value you pass to this function.

The default mod mask should be changed on application startup, before using any accelerator groups.

Glib::SignalProxy3< bool,const Glib::RefPtr<Glib::Object>&,guint,Gdk::ModifierType > Gtk::AccelGroup::signal_accel_activate | ( |  | ) |

Prototype:
  `bool on_my_accel_activate(const Glib::RefPtr<Glib::Object>& acceleratable, guint keyval, Gdk::ModifierType modifier)`

Glib::SignalProxy3< void,guint,Gdk::ModifierType,GClosure* > Gtk::AccelGroup::signal_accel_changed | ( |  | ) |

Prototype:
  `void on_my_accel_changed(guint keyval, Gdk::ModifierType modifier, GClosure* accel_closure)`

void Gtk::AccelGroup::unlock | ( |  | ) |

Undoes the last call to lock() on this accel_group.

static bool Gtk::AccelGroup::valid | ( | guint | keyval,
|  | Gdk::ModifierType | modifiers
| ) |  | `[static]`

Determines whether a given keyval and modifier mask constitute a valid keyboard accelerator.

For example, the 'a' keyval plus Gdk::CONTROL_MASK is valid - this is a "Ctrl+a" accelerator. But you can't, for instance, use the GDK_Control_L keyval as an accelerator.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::AccelGroup > wrap | ( | GtkAccelGroup * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/accelgroup.h